clc
clear all
close all
cvx_solver mosek
N=10;
epsilon_0=5;
pno = sqrt(10.^(-8));
theta_degree = -90:90;
theta_s = theta_degree*pi/180;
theta = [-45, 45,20,-20]*pi/180;
     n = 0:(N-1);
a_b = exp(1i * pi * n * sin(0)).';


F_var=20:10:50; %varing F

for nf_max=1:length(F_var)
   F_max=F_var( nf_max);
 
NUM=100;
for OUTITER = 1:NUM

% channel initialization

G_NLoS = 1/sqrt(2)*(normrnd(0,1,N,1)+1i*normrnd(0,1,N,1));
h_b = sqrt(0.001*(abs(50))^(-2.5))*G_NLoS.*a_b;
h_b = h_b/pno;


M = length(theta);
h_w_bar=sqrt(0.001*(abs(50))^(-2.5))/pno*1/sqrt(2)*(normrnd(0,1,N,1)+1i*normrnd(0,1,N,1));

%Gaussian 
k=0.01;
E_w=k*h_w_bar'*h_w_bar*eye(N)/N;
E_w_half=sqrt(E_w);
rou_c=0.05;


epsilon=0.01; 
P_a=5;
P_amax=10;
P_amin=1;


   for i=1:181
if (abs(i-45)<=5)||(abs(i-70)<=5)||(abs(i-135)<=5)||(abs(i-110)<=5)
    p_wanted(i)=1;
else
    p_wanted(i)=0;
end
end








P_IM = 7.5:0.5:10;%total power
PIM=10.^(P_IM/10);

for np=1:length(PIM)
   lam=0;
    PI = PIM(np);

    ro1 = 0.1;
ro2 = 0.1;
    ns=1;
    u_r_t = 1/sqrt(2)*(normrnd(0,1,N,1)+1i*normrnd(0,1,N,1));
for i = 1:N
	u_t1(i) = sqrt(0.5)*u_r_t(i)/abs(u_r_t(i));
end
u_r_r = 1/sqrt(2)*(normrnd(0,1,N,1)+1i*normrnd(0,1,N,1));
for i = 1:N
	u_r1(i) = sqrt(0.5)*u_r_r(i)/abs(u_r_r(i));
end

w_l=sqrt(1)*u_t1.';
w_l_ai =sqrt(1)* u_r1.';
 while(1)
cvx_begin sdp
            variables yita_1 yita_0 lamda pn_1 pn_2 x y tau
            variable W_1(N,N) complex semidefinite            
            variable T_bar(N,N) complex semidefinite
            variable W_ai(N,N) complex semidefinite
%H_1
 f=0;
             for i = 1:length(theta_s)
     n = 0:(N-1);
a = exp(1i * pi * n * sin(theta_s(i))).';
 f=f+square_pos(abs(yita_1*p_wanted(i)-a' * (W_1+T_bar+W_ai)* a));
             end

corr = 0;
             for k = 1:M
    for p = k+1:M
        a_k =  exp(1i * pi * n * sin(theta(k))).';
        a_p =  exp(1i * pi * n * sin(theta(p))).';
        corr = corr + square_pos(abs(a_k' * (W_1+T_bar+W_ai)* a_p));
    end
             end
F=1/length(theta_s)*f+2/(M*M-M)*corr; 



 f_0=0;
             for i = 1:length(theta_s)
     n = 0:(N-1);
a = exp(1i * pi * n * sin(theta_s(i))).';
 f_0=f_0+square_pos(abs(yita_0*p_wanted(i)-a' * (T_bar+W_ai)* a));
             end

corr_0 = 0;
             for k = 1:M
    for p = k+1:M
        a_k =  exp(1i * pi * n * sin(theta(k))).';
        a_p =  exp(1i * pi * n * sin(theta(p))).';
        corr_0 = corr_0 + square_pos(abs(a_k' * (T_bar+W_ai)* a_p));
    end
             end
F_0=1/length(theta_s)*f_0+2/(M*M-M)*corr_0; 




            maximize(tau-ro1*pn_1-ro2*pn_2)
            subject to
real(trace(E_w_half*(-(W_1-epsilon*(P_amax-P_amin)*(T_bar+W_ai)/P_a))*E_w_half))-real(sqrt( 2*rel_entr(1,rou_c))*x+rel_entr(1,1/rou_c)*y+h_w_bar'*(-(W_1-epsilon*(P_amax-P_amin)*(T_bar+W_ai)/P_a))*h_w_bar)>=0;
 


v_1=sqrt(2)*(E_w_half*(-(W_1-epsilon*(P_amax-P_amin)*(T_bar+W_ai)/P_a))*h_w_bar  );
v_2=vec((E_w_half*(-(W_1-epsilon*(P_amax-P_amin)*(T_bar+W_ai)/P_a))*E_w_half));
 v=[v_1; v_2]  ; 
 norm(v)<=x;

y*eye(N)+(E_w_half*(-(W_1-epsilon*(P_amax-P_amin)*(T_bar+W_ai)/P_a))*E_w_half)>=0;
y>=0;


real(h_b'*W_1*h_b) -real(lam*(1+h_b'*(W_ai+T_bar)*h_b ))>=tau;
 trace(W_ai+T_bar)==P_a;  trace(T_bar+W_ai+W_1)<=PI;

 W_1 >= 0;
  T_bar>= 0;
W_ai>= 0;
F<=F_max;

real(trace(W_1'*(eye(N)-w_l*w_l'))) <= pn_1;
 real(trace(W_ai'*(eye(N)-w_l_ai*w_l_ai'))) <= pn_2;
  pn_1 >= 0;
  pn_2 >= 0;
 cvx_end


  lam_iter(np,ns,OUTITER,nf_max)=lam;
lam=real(h_b'*W_1*h_b )/real((1+h_b'*(T_bar)*h_b ));
 R_s(np,ns,OUTITER,nf_max) = log2(1+lam);

 Loss(np,ns,OUTITER,nf_max)=F; zong(np,ns,OUTITER,nf_max)=F_0;
 U_1 =W_1;
	[V_1 D_1] = eigs(U_1); 
  	D1= diag(D_1);
	[a1 b1] = max(D1);
	w_l = V_1(:,b1);
    
    U_2 = W_ai;
	[V_2 D_2] = eigs(U_2);
  	D2= diag(D_2);
	[a2 b2] = max(D2);
	w_l_ai = V_2(:,b2);
if cvx_optval==-Inf
	break;
 end 

 if(pn_1>=0.0001)
        ro1 = ro1*1.01;
 end

 if(pn_2>=0.0001)
        ro2 = ro2*1.01;
 end



     if(ns>=2)
       if(max([pn_1,pn_2])<=0.0001)&&(tau<=0.001)
           Loss_all(np,OUTITER,nf_max)=F; R_b(np,OUTITER,nf_max) = R_s(np,ns,OUTITER,nf_max);
         break;
        end
    end
ns = ns + 1;



 end



end

end

end

average_1=mean( R_b(:,:,1),2);
average_2=mean( R_b(:,:,2),2);
average_3=mean( R_b(:,:,3),2);
average_4=mean( R_b(:,:,4),2);


 for i = 1:length(PIM)
   r1(i)=average_1(i,1);
end
 for i = 1:length(PIM)
   r2(i)=average_2(i,1);
end
 for i = 1:length(PIM)
   r3(i)=average_3(i,1);
 end
  for i = 1:length(PIM)
   r4(i)=average_4(i,1);
end
i = 2.5:0.5:5;%P_IM range 7.5:0.5:10, P_b range 2.5:0.5:5;
plot(i,  r1, '-c', LineWidth=1.5);hold on;
plot(i, r2, '-k', LineWidth=1.5);hold on;
plot(i, r3, '-m', LineWidth=1.5);hold on;
plot(i, r4, '-b', LineWidth=1.5);

