clc
clear all
close all
cvx_solver mosek
N=10;
epsilon_0=5;
pno = sqrt(10.^(-8));
theta_degree = -90:90;
theta_s = theta_degree*pi/180;
theta = [-45, 45,20,-20]*pi/180;
     n = 0:(N-1);
a_b = exp(1i * pi * n * sin(0)).';
NUM=100;
for OUTITER = 1:NUM

R_v=1:1:6; % varing R_b

for n_b=1:length(R_v)
    R_b=2^R_v( n_b)-1;

% channel initialization

G_NLoS = 1/sqrt(2)*(normrnd(0,1,N,1)+1i*normrnd(0,1,N,1));
h_b = sqrt(0.001*(abs(50))^(-2.5))*G_NLoS.*a_b;
h_b = h_b/pno;



M = length(theta);

u_r_t = 1/sqrt(2)*(normrnd(0,1,N,1)+1i*normrnd(0,1,N,1));
for i = 1:N
	u_t1(i) = sqrt(0.5)*u_r_t(i)/abs(u_r_t(i));
end

w_l=sqrt(1)*u_t1.';

   for i=1:181
if (abs(i-45)<=5)||(abs(i-70)<=5)||(abs(i-135)<=5)||(abs(i-110)<=5)
    p_wanted(i)=1;
else
    p_wanted(i)=0;
end
end

ns=1;ro1 = 0.1;
ro2 = 0.1;
 while(1)
cvx_begin sdp
            variables yita_1 yita_0 lamda pn_1 pn_2
            variable W_1(N,N) complex semidefinite            
            variable T_bar(N,N) complex semidefinite
            variable W_ai(N,N) complex semidefinite

 f=0;
             for i = 1:length(theta_s)
     n = 0:(N-1);
a = exp(1i * pi * n * sin(theta_s(i))).';
 f=f+square_pos(abs(yita_1*p_wanted(i)-a' * (W_1)* a));
             end

corr = 0;
             for k = 1:M
    for p = k+1:M
        a_k =  exp(1i * pi * n * sin(theta(k))).';
        a_p =  exp(1i * pi * n * sin(theta(p))).';
        corr = corr + square_pos(abs(a_k' * (W_1)* a_p));
    end
             end
F=1/length(theta_s)*f+2/(M*M-M)*corr; 


            minimize(F+ro1*pn_1)
            subject to



h_b'*W_1*h_b >=R_b*(1 );
  trace(W_1)==5;

 W_1 >= 0;
  T_bar>= 0;
W_ai>= 0;

real(trace(W_1'*(eye(N)-w_l*w_l'))) <= pn_1;

  pn_1 >= 0;
  pn_2 >= 0;
 cvx_end


 Loss(n_b,ns,OUTITER)=F;


if cvx_optval==-Inf
	break;
 end 

 if(pn_1>=0.0001)
        ro1 = ro1*1.5;
 end

 if(pn_2>=0.0001)
        ro2 = ro2*1.5;
 end



     if(ns>2)
       if(max([pn_1,pn_2])<=0.0001)&&(abs(Loss(n_b,ns,OUTITER)-Loss(n_b,ns-1,OUTITER))<=0.0001)
           Loss_converged(n_b,OUTITER) = Loss(n_b,ns,OUTITER);
         break;
        end
    end
ns = ns + 1;



end

end

end


average_1=mean( Loss_converged,2);



 for i = 1:length(R_v)
   r1(i)=average_1(i,1);
end


i = 1:length(R_v);
plot(i,  r1, '-c', LineWidth=1.5);